#include <iostream>
#include <string>
#include <dirent.h>
#include <fnmatch.h>
#include <stdlib.h>

using namespace std;

int main(int argc, char* argv[])
{
    if(!(argc-2)) // we have two parametrs
    {
	std::string dir(argv[1]);
	std::string mask("");
	unsigned slashpos=dir.rfind("/");
	mask=dir.substr(slashpos+1,dir.length()-slashpos-1);
	if(mask=="")
	    mask="*";
	dir=dir.substr(0,slashpos+1);
	if(dir=="")
	    dir=".";
	DIR* dirp = opendir(dir.c_str());
	if(dirp==NULL)
	{
	    cerr<<dir<<" - opening failed..."<<endl;
	    return 1;
	}
	struct dirent* dp;
	while ((dp = readdir(dirp)) != NULL)
	{
	    if(dp->d_type==DT_REG)
		if(0==fnmatch(mask.c_str(),dp->d_name,0))
		{
		    std::string filename=dp->d_name;
		    cout<<"Processing file "<<filename<<"..."<<endl;
		    if(filename.length()>=5)
		    {
			std::string ext(filename.substr(filename.length()-4,4));
			if(ext==".bz2")
			{
			    cout<<"Unpacking..."<<endl;
			    std::string cmd("bunzip2 ");
			    cmd+=filename;
			    system(cmd.c_str());
			    filename=filename.substr(0,filename.length()-4);
			}
		    }
		    cout<<"Processing..."<<endl;
		    std::string cmd="php in_local.php "+filename;
		    system(cmd.c_str());
		}
	}
	(void)closedir(dirp);
	return 0;
    }
    else
    {
	cerr<<"Invalid number of arguments"<<endl;
	return 1;
    }
}
